import { TimeEntryDto, TimeEntryCreateDto, TimeEntryUpdateDto } from "./dto";

export type TimeEntry = Omit<TimeEntryDto, "start" | "end"> & {
    start: Date;
    end: Date;
};

export const mapTimeEntryDtoToTimeEntry = (dto: TimeEntryDto): TimeEntry => ({
    ...dto,
    start: new Date(dto.start),
    end: new Date(dto.end),
});

export type TimeEntryCreate = Omit<TimeEntryCreateDto, "start" | "end"> & {
    start: Date;
    end: Date;
};

export const mapTimeEntryCreateDtoToTimeEntryCreate = (dto: TimeEntryCreateDto): TimeEntryCreate => ({
    ...dto,
    start: new Date(dto.start),
    end: new Date(dto.end),
});

export type TimeEntryUpdate = Omit<TimeEntryUpdateDto, "start" | "end"> & {
    start?: Date;
    end?: Date;
};

export const mapTimeEntryUpdateDtoToTimeEntryUpdate = (dto: TimeEntryUpdateDto): TimeEntryUpdate => ({
    ...dto,
    start: dto.start ? new Date(dto.start) : undefined,
    end: dto.end ? new Date(dto.end) : undefined,
});
